import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class ThinkTalk implements Runnable {

    private CyclicBarrier waitForIt;
    private Random        generator = new Random();


    public ThinkTalk(CyclicBarrier waitForIt) {
        this.waitForIt = waitForIt;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        try {
            Thread.sleep(generator.nextInt(30)+1);
        } catch (InterruptedException ex) { 
        }

        think();

        try {
            Thread.sleep(generator.nextInt(30)+1);
        } catch (InterruptedException ex) { 
        }

        talk();
    }

    public void think() {
        synchronized (System.out) {
            System.out.println("Think!");
        }
    }

    public void talk() {
        synchronized (System.out) {
            System.out.println("Talk!");
        }
    }

}
