import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class Tick implements Runnable {

    private CyclicBarrier waitForIt;
    private Random        generator = new Random();

    public Tick(CyclicBarrier waitForIt) {
        this.waitForIt = waitForIt;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        while (true) {
            try {
                Thread.sleep(generator.nextInt(30)+1);
            } catch (InterruptedException ex) { 
            }

            tick();
        }
    }

    public void tick() {
        synchronized (System.out) {
            System.out.println("Tick!");
        }
    }

}
