import java.util.concurrent.CyclicBarrier;

public class Main {

    public static void main(String[] argv) {
        CyclicBarrier barrier = new CyclicBarrier(3);
        CyclicBarrier ready   = new CyclicBarrier(3, new Ready());
        CyclicBarrier used    = new CyclicBarrier(3, new Used());

        Thread s = new Thread(new MakerA(barrier, ready, used));
        Thread t = new Thread(new MakerB(barrier, ready, used));
        Thread u = new Thread(new Assemble(barrier, ready, used));

        s.start();
        t.start();
        u.start();

    }
}
