import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class Resource implements Runnable {

    private CyclicBarrier waitForIt;
    private CyclicBarrier acquire;
    private CyclicBarrier release;
    private Random        generator = new Random();

    public Resource(CyclicBarrier waitForIt,
                    CyclicBarrier acquire,
                    CyclicBarrier release) {
        this.waitForIt = waitForIt;
        this.acquire   = acquire;
        this.release   = release;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        while (true) {
            try {
                acquire.await();
            } catch (InterruptedException ex) { 
            } catch (BrokenBarrierException ex) { 
            }

            try {
                release.await();
            } catch (InterruptedException ex) { 
            } catch (BrokenBarrierException ex) { 
            }
        }
    }

}
