import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class OnOff implements Runnable {

    private CyclicBarrier waitForIt;
    private Random        generator = new Random();


    public OnOff(CyclicBarrier waitForIt) {
        this.waitForIt = waitForIt;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        while (true) {
            try {
                Thread.sleep(generator.nextInt(30)+1);
            } catch (InterruptedException ex) { 
            }

            on();

            try {
                Thread.sleep(generator.nextInt(30)+1);
            } catch (InterruptedException ex) { 
            }

            off();
        }
    }

    public void on() {
        synchronized (System.out) {
            System.out.println("On!");
        }
    }

    public void off() {
        synchronized (System.out) {
            System.out.println("Off!");
        }
    }

}
